<?php
//Disallow direct Initialization for extra security.

if (!defined("IN_MYBB")) {
    die("You Cannot Access This File Directly. Please Make Sure IN_MYBB Is Defined.");
}

// Hooks
$plugins->add_hook('global_start', 'dfzgloszeniagraczy_global_start');

// Information
function dfzgloszeniagraczy_info()
{
    return array(
        "name"  => "(DF) Player Reports",
        "description" => "Displays reports from game servers",
        "website"        => "https://daffyy.tech",
        "author"        => "daffyy",
        "authorsite"    => "https://daffyy.tech",
        "version"        => "1.0",
        "guid"             => "",
        "compatibility" => "18*"
    );
}

// Activate
function dfzgloszeniagraczy_activate()
{
    global $db;

    $dfzgloszeniagraczy_group = array(
        'gid'    => 'NULL',
        'name'  => 'dfzgloszeniagraczy',
        'title'      => 'Player Reports',
        'description'    => 'Settings for Player Reports',
        'disporder'    => "1",
        'isdefault'  => "0",
    );
    $db->insert_query('settinggroups', $dfzgloszeniagraczy_group);
    $gid = $db->insert_id();

    $setting_array = array(
        // Enable
        'dfzgloszeniagraczy_enable' => array(
            'title' => 'Enable player submissions',
            'description' => 'If set to yes, you will enable notifications.',
            'optionscode' => 'yesno',
            'value' => 1,
            'disporder' => 1
        ),
        // Group Select
        'dfzgloszeniagraczy_groups' => array(
            'title' => 'Who sees?',
            'description' => 'Groups that can see reports.',
            'optionscode' => 'groupselect',
            'value' => '1',
            'disporder' => 2
        ),
        // Host
        'dfzgloszeniagraczy_host' => array(
            'title' => 'Host',
            'description' => 'Database host.',
            'optionscode' => "text",
            'value' => '0.0.0.0',
            'disporder' => 3
        ),
        // User
        'dfzgloszeniagraczy_user' => array(
            'title' => 'Username',
            'description' => 'Database user.',
            'optionscode' => "text",
            'value' => 'root',
            'disporder' => 4
        ),
        // Password
        'dfzgloszeniagraczy_pass' => array(
            'title' => 'Password',
            'description' => 'Database user password.',
            'optionscode' => "text",
            'value' => '*******',
            'disporder' => 5
        ),
        // Database
        'dfzgloszeniagraczy_database' => array(
            'title' => 'Baza danych',
            'description' => 'Database name.',
            'optionscode' => "text",
            'value' => 'database_name',
            'disporder' => 6
        ),
        // Group Select
        'dfzgloszeniagraczy_groups' => array(
            'title' => 'Who Sees?',
            'description' => 'Groups that can see reports.',
            'optionscode' => 'groupselect',
            'value' => '1',
            'disporder' => 7
        ),
        // Group Select
        'dfzgloszeniagraczy_limit' => array(
            'title' => 'Limit',
            'description' => 'How many reports to display.',
            'optionscode' => 'numeric',
            'value' => '5',
            'disporder' => 8
        ),
    );

    foreach ($setting_array as $name => $setting) {
        $setting['name'] = $name;
        $setting['gid'] = $gid;

        $db->insert_query('settings', $setting);
    }

    require_once MYBB_ROOT . "/inc/adminfunctions_templates.php";
    find_replace_templatesets("index", '#' . preg_quote('{$forums}') . '#', '{$dfzgloszeniagraczy} <br/>{$forums}');
    find_replace_templatesets("headerinclude", '#' . preg_quote('<link type="text/css" rel="stylesheet" href="{$mybb->settings[\'bburl\']}/admin/styles/dfzgloszeniagraczy.css"/>')
        . '#', '', 0);

    rebuild_settings();
}

// Deactivate
function dfzgloszeniagraczy_deactivate()
{
    global $mybb, $db;
    $db->query("DELETE FROM " . TABLE_PREFIX . "settings WHERE name LIKE '%dfzgloszeniagraczy%'");
    $db->query("DELETE FROM " . TABLE_PREFIX . "settinggroups WHERE name='dfzgloszeniagraczy'");
    require "../inc/adminfunctions_templates.php";
    find_replace_templatesets("index", '#' . preg_quote('{$dfzgloszeniagraczy} <br/>') . '#', '', 0);
    find_replace_templatesets("headerinclude", '#' . preg_quote('{$stylesheets}') . '#', '{$stylesheets}
	<link type="text/css" rel="stylesheet" href="{$mybb->settings[\'bburl\']}/admin/styles/dfzgloszeniagraczy.css"/>');
    rebuild_settings();
    $mybb->cache->delete('dfzgloszeniagraczy');
}

function dfzgloszeniagraczy_global_start()
{
    global $mybb, $dfzgloszeniagraczy;

    if ($mybb->settings['dfzgloszeniagraczy_enable'] != 1) {
        return;
    }

    // explode...
    $groups_allowed = explode(',', $mybb->settings['dfzgloszeniagraczy_groups']);

    if ($mybb->settings['dfzgloszeniagraczy_groups'] == '-1' || in_array($mybb->user['usergroup'], $groups_allowed)) {
        $result = "";

        $cache = $mybb->cache->read('dfzgloszeniagraczy');
        if (empty($cache) || $cache['time'] <= TIME_NOW) {
            try {
                $db = new PDO(
                    "mysql:host=" . $mybb->settings['dfzgloszeniagraczy_host'] . ";dbname=" . $mybb->settings['dfzgloszeniagraczy_database'] . ";charset=utf8mb4",
                    $mybb->settings['dfzgloszeniagraczy_user'],
                    $mybb->settings['dfzgloszeniagraczy_pass']
                );

                $select = $db->query("SELECT * FROM `mReport` ORDER BY id DESC LIMIT " . $mybb->settings['dfzgloszeniagraczy_limit']);
                $select = $select->fetchAll();

                foreach ($select as $row) {
                    if (dfzgloszeniagraczy_skipAdvert($row['report_reason'])) continue;
                    $img = "https://www.gametracker.com/images/game_icons16/";
                    $row['client_name'] = str_replace('?', '', $row['client_name']);
                    $row['target_name'] = str_replace('?', '', $row['target_name']);
                    switch ($row['game']) {
                        case "cs16":
                            $img .= "cs.png";
                            $title = "Counter-Strike 1.6";
                            $row['client_steamid'] = dfzgloszeniagraczy_toCommunityId($row['client_steamid']);
                            $row['target_steamid'] = dfzgloszeniagraczy_toCommunityId($row['target_steamid']);
                            break;
                        default:
                            $img .= "csgo.png";
                            $title = "Counter-Strike: Global Offensive";
                            break;
                    }

                    $row['report_reason'] = dfzgloszeniagraczy_censorWords($row['report_reason']);

                    $result .= '
<tr>
    <td width="3%" class="tcat dfzgloszenia_td dfzgloszenia_img" align="right" valign="bottom"><img src="' . $img . '" title="' . $title . '"/></td>
    <td class="tcat dfzgloszenia_text" align="left" valign="center"><span class="smalltext" style="font-size: 13px;"><strong>
    <a href="https://steamcommunity.com/profiles/' . $row['client_steamid'] . ' " target="_blank" title="Przejdź do profilu ' . $row['client_name'] . '">' .
                        $row['client_name'] . '</a></strong>
     zgłasza <strong><a href="https://steamcommunity.com/profiles/' . $row['target_steamid'] . ' " target="_blank" title="Przejdź do profilu ' . $row['target_name'] . '">' .
                        $row['target_name'] . '</a>
</strong> za <strong>' . strip_tags($row['report_reason']) . '</strong> na <strong>' . $row['server_name'] . '</strong></span></td>
<td class="tcat dfzgloszenia_time">' . my_date('relative', $row['time'], null, 1, true) . '</td>
</tr>
' . PHP_EOL;
                }
                if (count($select) == 0) {
                    $result = '
                <tr>
                    <td class="tcat" align="left"><strong>Brak zgłoszeń!</strong></td>
                </tr>
                ';
                }
                $cache = array(
                    'time'        => TIME_NOW + 60,
                    'data'        => $result,
                );

                $mybb->cache->update('dfzgloszeniagraczy', $cache);
            } catch (Exception $e) {
                $result = '
            <tr>
                <td class="tcat" align="left"><strong>An error has occurred with connecting to database or just database error!</strong></td>
            </tr>';
            }
        } else {
            $result = $cache['data'];
        }

        $dfzgloszeniagraczy = '
        <table border="0" cellspacing="0" cellpadding="5" class="tborder dfzgloszenia_table">
            <thead>
                <tr>
                <td class="thead" colspan="5" class="dfzgloszenia_td">
                <div class="expcolimage class="dfzgloszenia_exp""><img src="http://localhost/MYBB/images/collapse.png" id="cat_dfzgloszeniagraczy_img" class="expander" alt="[-]" title="[-]" style="cursor: pointer;"></div>
                <div class="dfzgloszenia_title"><strong>Player Reports</strong></div>
                </td>
                </tr>
            </thead>
            <tbody class="dfzgloszenia_tbody" style="" id="cat_dfzgloszeniagraczy_e">
            ' . $result . '
            </tbody>
        </table>
        ';
    }
}

function dfzgloszeniagraczy_toCommunityId($id)
{
    if (preg_match('/^STEAM_/', $id)) {
        $parts = explode(':', $id);
        return bcadd(bcadd(bcmul($parts[2], '2'), '76561197960265728'), $parts[1]);
    } elseif (is_numeric($id) && strlen($id) < 16) {
        return bcadd($id, '76561197960265728');
    } else {
        return $id; // We have no idea what this is, so just return it.
    }
}

function dfzgloszeniagraczy_censorWords($msg)
{
    return str_replace([
        'kurw',
        'huj',
        'jeba',
        'skurw',
        'kutas',
        'cip',
        'cwel',
        'peda',
        'suka',
        'jeban',
        'dupa'
    ], "***", strip_tags($msg));
}

function dfzgloszeniagraczy_skipAdvert($msg)
{
    if (
        preg_match('/[0-9]{2,3}.[0-9]{2,3}.[0-9]{2,3}.[0-9]{2,3}(:[0-9]{4,8})?/', $msg) ||
        preg_match('/(http[s]?\:\/\/)?(?!\-)(?:[a-zA-Z\d\-]{0,62}[a-zA-Z\d]\.){1,126}(?!\d+)[a-zA-Z\d]{1,63}/', $msg)
    ) {
        return true;
    }
    return false;
}
